//
// Created by QP on 2025/4/12.
//

#ifndef PCL_WRAPPER_PCL_WRAPPER_API_HPP
#define PCL_WRAPPER_PCL_WRAPPER_API_HPP
#pragma once
#ifdef __cplusplus
extern "C" {
#endif

// ========== Cloud ==========

void* create_pointcloud_xyz();
void* create_pointcloud_xyzi();
void  resize_pointcloud_xyz(void* cloud, int count);
void  resize_pointcloud_xyzi(void* cloud, int count);
void  set_point_xyz(void* cloud, int index, float x, float y, float z);
void  set_point_xyzi(void* cloud, int index, float x, float y, float z, float intensity);
int get_pointcloud_size_xyz(void* cloud);
int get_pointcloud_size_xyzi(void* cloud);
bool get_point_xyz(void* cloud, int index, float* x, float* y, float* z); // 读取 PointXYZ
bool get_point_xyzi(void* cloud, int index, float* x, float* y, float* z, float* intensity); // 读取 PointXYZI
void delete_pointcloud_xyz(void* cloud);
void delete_pointcloud_xyzi(void* cloud);

// ========== Voxel Filter ==========

void* create_voxel_filter_xyz();
void* create_voxel_filter_xyzi();
void  set_voxel_leaf_size(void* filter, float lx, float ly, float lz);
void  set_voxel_input_cloud(void* filter, void* cloud);
void* apply_voxel_filter_xyz(void* filter);
void* apply_voxel_filter_xyzi(void* filter);
void  delete_voxel_filter(void* filter);

// ========== KdTree ==========
void* create_kdtree_xyz();
void set_kdtree_input_cloud_xyz(void* kdtree, void* cloud);
int knn_search_xyz(void* kdtree, float x, float y, float z, int k,
                   int* out_indices, float* out_distances);
int radius_search_xyz(void* kdtree, float x, float y, float z, float radius,
                      int* out_indices, float* out_distances, int max_count);
void delete_kdtree_xyz(void* kdtree);

// ========= IO ==========
bool load_pcd_xyz(const char* filename, void* out);
bool load_pcd_xyzi(const char* filename, void* out);
bool save_pcd_xyz(const char* filename, void* cloud);
bool save_pcd_xyzi(const char* filename, void* cloud);

#ifdef __cplusplus
}
#endif

#endif //PCL_WRAPPER_PCL_WRAPPER_API_HPP
